package uy.edu.fing.tse.central.db.entity;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
@NamedQueries({
        //@NamedQuery(name = "Periferico.findAll", query = "select c from Categoria c"),
        //@NamedQuery(name = "Periferico.findByName", query = "select c from Categoria c where c.name = :name")
})
public final class Hecho {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(nullable = false)
    private String title;
    private String description;

    @ManyToOne(optional = false)
    private Estado actualState;

    @ManyToOne
    private Calificacion score;

    @ManyToOne
    private Categoria category;

    @OneToMany
    private List<TransicionEstado> history = new ArrayList<>();

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Estado getActualState() {
        return actualState;
    }

    public void setActualState(Estado actualState) {
        this.actualState = actualState;
    }

    public Calificacion getScore() {
        return score;
    }

    public void setScore(Calificacion score) {
        this.score = score;
    }

    public Categoria getCategory() {
        return category;
    }

    public void setCategory(Categoria category) {
        this.category = category;
    }

    public List<TransicionEstado> getHistory() {
        return history;
    }

    public void setHistory(List<TransicionEstado> history) {
        this.history = history;
    }

    public void addHistory(TransicionEstado history) {
        this.history.add(history);
    }
}
