package uy.edu.fing.tse.central.db.entity;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;


@Entity
@NamedQueries({
        @NamedQuery(name = "Periferico.findAll", query = "SELECT p FROM Periferico p"),
        @NamedQuery(name = "Periferico.findById", query = "SELECT p FROM Periferico p WHERE p.id = :id"),
        @NamedQuery(name = "Periferico.findByCategoria", query = "SELECT p FROM Periferico p INNER JOIN p.categories AS c WHERE c.name = :name")
})
public final class Periferico extends Mecanismo {

    @ManyToMany //todo: verificar que funcione
    private List<Categoria> categories = new ArrayList<>();

    @Column(nullable = false)
    private String endpoint;

    public List<Categoria> getCategories() {
        if (categories == null) {
            categories = new ArrayList<>();
        }
        return categories;
    }

    public void addCategory(Categoria categoria) {
        this.categories.add(categoria);
    }

    public void setCategories(List<Categoria> categorias) {
        this.categories = categorias;
    }

    public String getEndpoint() {
        return endpoint;
    }

    public void setEndpoint(String endpoint) {
        this.endpoint = endpoint;
    }

}
